//cut point reid for rootstock plant
#pragma once
#include <time.h>
#include <opencv.hpp>
#include "data_def_api.h"
#include "data_def.h"
#include "logger.h"
#include "imstorage_manager.h"

//using namespace cv;
namespace graft_cv{

class CRootStockCutPointReid{
public:
	CRootStockCutPointReid(ConfigParam&c,CGcvLogger*pLog=0);
	~CRootStockCutPointReid();
	int cut_point_reid(			//киʶ
		ImgInfo*,				//кͼƬ
		cv::Mat&,					//кͼƬ
		const char * pre_img_id,		//ǰͼid
		PositionInfo& posinfo,	
		map<string, cv::Mat>& img_cache
		);	
	void set_image_saver(CImStoreManager** ppis){m_ppImgSaver=ppis;}
private:
	cv::Mat m_preGrayImg;// gray image
	//Mat m_binImg;// binary image
	cv::Mat m_grayImg;// gray image
	cv::Mat m_edgeImg;
	string m_imgId;
	CImStoreManager** m_ppImgSaver;

	//ͼƬڵ
	ImgInfo* m_pImginfoBinFork;//fork-y, right-x
	ImgInfo* m_pImgCorners;//corners, reference-point, candidate box
	ImgInfo* m_pImgCutPoint;//reference-point, cutpoint


	//global configure parameters
	ConfigParam& m_cparam;
	CGcvLogger * m_pLogger;
	// image segment
	void img_preprocess(cv::Mat&);
	void clear_imginfo();
	
};
};